import type { IntegroApp } from './types/IntegroApp';
declare const isLazyModule: unique symbol;
type Importer<T extends IntegroApp> = () => Promise<T>;
export type LazyModule<T extends IntegroApp> = Importer<T> & {
    [isLazyModule]: true;
};
export type MaybeLazyModule<T extends IntegroApp> = Importer<T> & {
    [isLazyModule]?: true;
};
export declare const lazy: <T extends IntegroApp>(importer: Importer<T>) => LazyModule<T>;
export declare const isLazy: <T extends IntegroApp>(fn: MaybeLazyModule<T>) => fn is LazyModule<T>;
export {};
